org.eclipse.jgit.transport

## Interface PreUploadHook

All Known Implementing Classes:
  PreUploadHookChain

    public interface PreUploadHook

Hook invoked by `UploadPack` before during critical phases.

If any hook function throws `ServiceMayNotContinueException` then processing stops immediately and the exception is thrown up the call stack. Most phases of UploadPack will try to report the exception's message text to the end-user over the client's protocol connection.

### Field Summary

Fields
`static PreUploadHook` `NULL` A simple no-op hook.

### Method Summary

Methods
`void` `onBeginNegotiateRound(UploadPack up, Collection<? extends ObjectId> wants, int cntOffered)` Invoked before negotiation round is started.
`void` `onEndNegotiateRound(UploadPack up, Collection<? extends ObjectId> wants, int cntCommon, int cntNotFound, boolean ready)` Invoked after a negotiation round is completed.
`void` `onSendPack(UploadPack up, Collection<? extends ObjectId> wants, Collection<? extends ObjectId> haves)` Invoked just before a pack will be sent to the client.

### Field Detail

#### NULL

    static final PreUploadHook NULL

A simple no-op hook.

### Method Detail

#### onBeginNegotiateRound

    void onBeginNegotiateRound(UploadPack up,
                             Collection<? extends ObjectId> wants,
                             int cntOffered)
                               throws ServiceMayNotContinueException

Invoked before negotiation round is started.

Parameters:
  `up` - the upload pack instance handling the connection.
  `wants` - the list of wanted objects.
  `cntOffered` - number of objects the client has offered.
Throws:
  `ServiceMayNotContinueException` - abort; the message will be sent to the user.

#### onEndNegotiateRound

    void onEndNegotiateRound(UploadPack up,
                           Collection<? extends ObjectId> wants,
                           int cntCommon,
                           int cntNotFound,
                           boolean ready)
                             throws ServiceMayNotContinueException

Invoked after a negotiation round is completed.

Parameters:
  `up` - the upload pack instance handling the connection.
  `wants` - the list of wanted objects.
  `cntCommon` - number of objects this round found to be common. In a smart HTTP transaction this includes the objects that were previously found to be common.
  `cntNotFound` - number of objects in this round the local repository does not have, but that were offered as potential common bases.
  `ready` - true if a pack is ready to be sent (the commit graph was successfully cut).
Throws:
  `ServiceMayNotContinueException` - abort; the message will be sent to the user.

#### onSendPack

    void onSendPack(UploadPack up,
                  Collection<? extends ObjectId> wants,
                  Collection<? extends ObjectId> haves)
                    throws ServiceMayNotContinueException

Invoked just before a pack will be sent to the client.

Parameters:
  `up` - the upload pack instance handling the connection.
  `wants` - the list of wanted objects. These may be RevObject or RevCommit if the processed parsed them. Implementors should not rely on the values being parsed.
  `haves` - the list of common objects. Empty on an initial clone request. These may be RevObject or RevCommit if the processed parsed them. Implementors should not rely on the values being parsed.
Throws:
  `ServiceMayNotContinueException` - abort; the message will be sent to the user.